#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

class Product
{
    string name;
    int productSize;
public:
    Product(string n, int s)
    {
        name = n;
        productSize = s;
    }
    bool equals(Product *p)
    {
        return name==p->name and productSize==p->productSize;
    }
    string toString()
    {
        stringstream ss;
        ss<<name<<" nr. "<<productSize;
        return ss.str();
    }
};
class Shelf
{
    string name;
    vector<Product*> products;
public:
    Shelf(string s)
    {
        name=s;
    }
    string dispatch(Product *prod)
    {
        for(int j=0;j<products.size();j++)
            if(prod->equals(products[j]))
            {
                products.erase(products.begin()+j);
                return name;  // kui kustutatud
            }

        return "";
    }
    int getItemCount(Product *prod)
    {
        int counter = 0;
        for(int j=0;j<products.size();j++)
            if(prod->equals(products[j]))
                counter++;

        return counter;
    }

    bool receive(Product *prod, string loc)
    {
        if(name==loc)
        {
            products.push_back(prod);
            return true;
        }
        else
            return false;
    }
    string toString()
    {
        string result = name;
        result+="\n";
        for(int j=0;j<products.size();j++)
        {
            result+="\t";
            result+=products[j]->toString();
            result+="\n";
        }

        return result;
    }
};
class Warehouse
{
    vector<Shelf*> shelfs;
public:
    string dispatch(Product *prod)
    {
        for(int i=0;i<shelfs.size();i++)
        {
            string name = shelfs[i]->dispatch(prod);
            if(name!="")
                return name;
        }
         return "";  // sellist kaupa pole
    }
    int getItemCount(Product *prod)
    {
        int counter = 0;
        for(int i=0;i<shelfs.size();i++)
            counter += shelfs[i]->getItemCount(prod);

        return counter;
    }
    void receive(Product  *prod, string loc)
    {
        for(int i=0;i<shelfs.size();i++)
            if( shelfs[i]->receive(prod,loc) )
                return;

        Shelf *q = new Shelf(loc);
        q->receive(prod,loc);
        shelfs.push_back(q);
    }
    string toString()
    {
        string result = "    *** LADU ***\n";
        for(int i=0;i<shelfs.size();i++)
        {
            result += shelfs[i]->toString();
            result += "\n";
        }

        return result;
    }

};
int main()
{
    //loome kaubad
    Product *ps1 = new Product("sokid", 42);
    Product *ps2 = new Product("sokid", 42);
    Product *pk1 = new Product("kindad", 10);
    Product *pk2 = new Product("kindad", 9);
    Product *pm = new Product("mantel", 60);
    Product *pp = new Product("pksid", 56);

    // Kontrollime equals() toimimist
    cout<<ps1->equals(ps1)<<endl; // true
    cout<<ps1->equals(ps2)<<endl; // true
    cout<<ps2->equals(ps1)<<endl; // true
    cout<<ps1->equals(pk1)<<endl; // false

    // Testime lao toimimist
    // lisame kaubad lattu
    Warehouse w;
    w.receive(ps1, "A");
    w.receive(pk1, "A");
    w.receive(pk2, "B");
    w.receive(ps2, "B");
    w.receive(pm, "B");
    w.receive(pp, "L");

    cout<<w.toString()<<endl;

    cout<<ps1->toString()<<" on laos " << w.getItemCount(ps1) <<" tk\n"; //2tk
    cout<<ps2->toString()<<" on laos " << w.getItemCount(ps2) <<" tk\n"; //2 tk
    cout<<pk1->toString()<<" on laos " << w.getItemCount(pk1) <<" tk\n"; //1 tk

    // loome otsitava kauba
    Product *po1 = new Product("sokid", 42);

    // vljastame laost kauba:
    if (w.dispatch(po1) != "") {
         cout<< "Vljastasin toote " << po1->toString() << " asukohalt " <<w.dispatch(po1) <<endl;
    } else {
        cout<< "Toodet "<< po1->toString()<<"  ei leitud loast"<<endl;
    }
    // kontrolliks prindime vlja laoseisu ja vaatame, kas antud kauba kogus on vhenenud
    cout<<ps1->toString()<<" on laos " << w.getItemCount(ps1) <<" tk\n"; //0 tk

    cout<<w.toString()<<endl;
}
